<template>
  <div class="">
    <div class="login-container pt-5">
      <div class="el-col el-col-24 text-center"><span class="logo-container"><img src="/images/logo-large.png" class="login-logo"></span></div>
      <el-form ref="loginForm" :model="loginForm" :rules="loginRules" class="login-form" auto-complete="on" label-position="left">
        <div class="el-col el-col-24 form-title">
          <el-row>
            <el-col :span="4">
              <lang-select class="set-language" />
            </el-col>
            <el-col :span="24">
              <h3 class="title">
                {{ $t('login.title') }}
              </h3>
            </el-col>
          </el-row>
        </div>
        <div class="el-col el-col-24">
          <!--<BaseTimer :time-left="timeLeft" />-->
          <div class="el-col el-col-24 my-login-form">
            <el-row class="mt-3 mb-3">
              <el-col :span="24">
                <span class="message">
                  {{ $t('login.pleaseLogin') }}
                </span>
              </el-col>
            </el-row>
            <el-row>
              <el-col :span="12" class="fa-label">
                <span>
                  {{ $t('login.email') }}
                </span>
              </el-col>
            </el-row>
            <el-form-item prop="email">
              <span class="svg-container">
                <svg-icon icon-class="user" />
              </span>
              <el-input v-model="loginForm.email" name="email" type="text" auto-complete="on" :placeholder="$t('login.email')" />
            </el-form-item>
            <el-row>
              <el-col :span="6" class="fa-label">
                <span>
                  {{ $t('login.password') }}
                </span>
              </el-col>
              <el-col :span="18">
                <span class="forget-password-link mr-1">
                  <span @click="handleForgetPassword">
                    {{ $t('login.forgetPassword') }}
                  </span>
                </span>
              </el-col>
            </el-row>
            <el-form-item prop="password">
              <span class="svg-container">
                <svg-icon icon-class="password" />
              </span>
              <el-input
                v-model="loginForm.password"
                :type="pwdType"
                name="password"
                auto-complete="on"
                :placeholder="$t('login.password')"
                @keyup.enter.native="handleLogin"
              />
              <span class="show-pwd" @click="showPwd">
                <svg-icon icon-class="eye" />
              </span>
            </el-form-item>
            <el-row class="mt-2">
              <el-col :span="24">
                <el-form-item class="btn-noborder">
                  <el-button class="border border-0" :loading="loading" type="primary" style="width:100%;" @click.native.prevent="handleLogin">
                    {{ $t('login.logIn') }}
                  </el-button>
                </el-form-item>
              </el-col>
            </el-row>
          </div>
        </div>
        <div class="el-col el-col-24 form-footer">
          <el-row class="footer">
            <el-col :span="24" class="fa-label register-link">
              {{ $t('login.newUser') }}
              <span @click="handleRegister">
                {{ $t('login.register') }}
              </span>
            </el-col>
          </el-row>
        </div>
      </el-form>
    </div>
    <el-dialog :title="$t('user.registerTitleForm')" :visible.sync="dialogFormVisible">
      <div v-loading="userCreating" class="form-container">
        <el-form ref="userForm" :model="newUser" label-position="left" class="register-form" style="max-width: 500px;">
          <el-form-item :label="$t('user.name')" prop="name">
            <el-input v-model="newUser.name" :placeholder="$t('user.name')" />
          </el-form-item>
          <el-form-item :label="$t('user.family')" prop="name">
            <el-input v-model="newUser.family" :placeholder="$t('user.family')" />
          </el-form-item>
          <el-form-item :label="$t('user.nationalcode')" prop="name">
            <el-input v-model="newUser.nationalcode" :placeholder="$t('user.nationalcode')" />
          </el-form-item>
          <div class="el-form-item el-form-item--medium">
            <label class="el-form-item__label">
              {{ $t('user.nationalcodeFile') }}
            </label>
            <div class="button-wrap">
              <label class="new-button" for="upload"> {{ $t('user.uploadFile') }}
                <input id="upload" type="file" @change="onImageChange">
              </label>
            </div>
          </div>
          <el-form-item :label="$t('user.mobile')" prop="name">
            <el-input v-model="newUser.mobile" :placeholder="$t('user.mobile')" />
          </el-form-item>
          <el-form-item :label="$t('user.password')" prop="password">
            <el-input v-model="newUser.password" show-password :placeholder="$t('user.password')" />
          </el-form-item>
          <el-form-item :label="$t('user.confirmPassword')" prop="confirmPassword">
            <el-input v-model="newUser.confirmPassword" show-password :placeholder="$t('user.confirmPassword')" />
          </el-form-item>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">
          {{ $t('table.cancel') }}
        </el-button>
        <el-button type="primary" @click="createUser()">
          {{ $t('table.confirm') }}
        </el-button>
      </div>
    </el-dialog>
    <el-dialog :title="$t('user.validateUserForm')" :visible.sync="validateUserFormVisible">
      <div v-loading="validateLoading" class="form-container">
        <el-form ref="verificationForm" :model="validateUser" label-position="left" class="register-form" style="max-width: 500px;">
          <el-form-item :label="$t('form.verification_code')" prop="name">
            <el-input v-model="validateUser.verification_code" :placeholder="$t('form.verification_code')" />
          </el-form-item>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="validateUserFormVisible = false">
          {{ $t('table.cancel') }}
        </el-button>
        <el-button type="primary" @click="sendVerification()">
          {{ $t('table.confirm') }}
        </el-button>
      </div>
    </el-dialog>
    <el-dialog :title="$t('user.forgetPasswordForm')" :visible.sync="forgetPasswordFormVisible">
      <div v-if="forgetPasswordUsername">
        <div v-loading="forgetPasswordLoading" class="form-container">
          <el-form ref="verificationForm" :model="forgetPassword" label-position="left" class="register-form" style="max-width: 500px;">
            <el-form-item :label="$t('user.mobile')" prop="name">
              <el-input v-model="forgetPassword.mobile" :placeholder="$t('user.mobile')" />
            </el-form-item>
          </el-form>
        </div>
        <div slot="footer" class="dialog-footer">
          <el-button @click="forgetPasswordFormVisible = false">
            {{ $t('table.cancel') }}
          </el-button>
          <el-button type="primary" @click="sendForgetPassword()">
            {{ $t('table.confirm') }}
          </el-button>
        </div>
      </div>
      <div v-if="forgetPasswordValidatedCode">
        <div v-loading="validateLoading" class="form-container">
          <el-form ref="verificationForm" :model="validatedCode" label-position="left" class="register-form" style="max-width: 500px;">
            <div class="el-form-item el-form-item--medium">
              <label class="el-form-item__label">
                {{ $t('form.verification_code') }} (<timer :time="prettyTime" />)
              </label>
              <div class="el-form-item__content">
                <div class="el-input el-input--medium">
                  <input v-model="forgetPassword.verification_code" :placeholder="$t('form.verification_code')" type="text" autocomplete="off" class="el-input__inner">
                </div>
              </div>
            </div>
            <!--<el-form-item :label="$t('form.verification_code')" prop="name">-->
            <!--<timer :time="prettyTime" />-->
            <!--<el-input v-model="forgetPassword.verification_code" :placeholder="$t('form.verification_code')" />-->
            <!--</el-form-item>-->
          </el-form>
        </div>
        <div v-loading="validateLoading" class="form-container">
          <el-form ref="verificationForm" :model="validatedCode" label-position="left" class="register-form" style="max-width: 500px;">
            <div class="el-form-item el-form-item--medium">
              <label class="el-form-item__label">
                {{ $t('user.password') }}
              </label>
              <div class="el-form-item__content">
                <div class="el-input el-input--medium">
                  <input v-model="forgetPassword.password" :placeholder="$t('form.verification_code')" type="password" autocomplete="off" class="el-input__inner">
                </div>
              </div>
            </div>
          </el-form>
        </div>
        <div v-loading="validateLoading" class="form-container">
          <el-form ref="verificationForm" :model="validatedCode" label-position="left" class="register-form" style="max-width: 500px;">
            <div class="el-form-item el-form-item--medium">
              <label class="el-form-item__label">
                {{ $t('user.confirmPassword') }}
              </label>
              <div class="el-form-item__content">
                <div class="el-input el-input--medium">
                  <input v-model="forgetPassword.confirmPassword" :placeholder="$t('user.confirmPassword')" type="password" autocomplete="off" class="el-input__inner">
                </div>
              </div>
            </div>
          </el-form>
        </div>
        <div slot="footer" class="dialog-footer">
          <el-button @click="forgetPasswordFormVisible = false">
            {{ $t('table.cancel') }}
          </el-button>
          <el-button type="primary" @click="verifyForgetPassword()">
            {{ $t('table.confirm') }}
          </el-button>
        </div>
      </div>
    </el-dialog>
    <el-dialog :title="$t('user.validateUserForm')" :visible.sync="verificationFormVisible">
      <div v-loading="validateLoading" class="form-container">
        <el-form ref="verificationForm" :model="newVerification" label-position="left" class="register-form" style="max-width: 500px;">
          <el-form-item :label="$t('field.mobile')" prop="mobile">
            <el-input v-model="newVerification.mobile" :placeholder="$t('field.mobile')" />
          </el-form-item>
          <el-form-item :label="$t('form.verification_code')" prop="verification_code">
            <el-input v-model="newVerification.verification_code" :placeholder="$t('form.verification_code')" />
          </el-form-item>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="verificationFormVisible = false">
          {{ $t('table.cancel') }}
        </el-button>
        <el-button type="primary" @click="sendNewVerification()">
          {{ $t('table.confirm') }}
        </el-button>
        <el-button type="primary" @click="newVerificationCode()">
          {{ $t('table.newVerificationCode') }}
        </el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import LangSelect from '@/components/LangSelect';
// import { validEmail } from '@/utils/validate';
import UserResource from '@/api/user';
import axios from 'axios';

const userResource = new UserResource();
import Cookies from 'js-cookie';
// import BaseTimer from './components/BaseTimer';
const Timer = {
  template: `
		 <div class="timer">{{ time | prettify }}</div>
	`,
  props: ['time'],
  filters: {
    prettify: function(value) {
      const data = value.split(':');
      let minutes = data[0];
      let secondes = data[1];
      if (minutes < 10) {
        minutes = '0' + minutes;
      }
      if (secondes < 10) {
        secondes = '0' + secondes;
      }
      return minutes + ':' + secondes;
    },
  },
};
export default {
  name: 'Login',
  components: { LangSelect, 'timer': Timer },
  data() {
    // const validateEmail = (rule, value, callback) => {
    //   if (!validEmail(value)) {
    //     callback(new Error('Please enter the correct email'));
    //   } else {
    //     callback();
    //   }
    // };
    var lang = Cookies.get('language') ? Cookies.get('language') : 'fa';
    var body = document.body;
    if (lang === 'fa'){
      body.classList.add('rtl');
      body.classList.remove('ltr');
    } else {
      body.classList.remove('rtl');
      body.classList.add('ltr');
    }
    const validatePass = (rule, value, callback) => {
      if (value.length < 4) {
        callback(new Error('Password cannot be less than 4 digits'));
      } else {
        callback();
      }
    };
    return {
      loginForm: {
        email: '',
        password: '',
      },
      time: 120,
      timeLimit: 20,
      timePassed: 0,
      newUser: {},
      newVerification: {},
      validateUser: {},
      forgetPassword: {},
      validatedCode: {},
      nonAdminRoles: ['editor', 'user', 'visitor'],
      dialogFormVisible: false,
      validateUserFormVisible: false,
      forgetPasswordFormVisible: false,
      forgetPasswordValidatedCode: false,
      forgetPasswordUsername: true,
      verificationFormVisible: false,
      userCreating: false,
      loginRules: {
        email: [{ required: true, trigger: 'blur' }],
        password: [{ required: true, trigger: 'blur', validator: validatePass }],
      },
      loading: false,
      forgetPasswordLoading: false,
      validateLoading: false,
      pwdType: 'password',
      redirect: undefined,
    };
  },
  computed: {
    formattedTimeLeft() {
      const timeLeft = this.timeLeft;
      // The largest round integer less than or equal to the result of time divided being by 60.
      const minutes = Math.floor(timeLeft / 60);
      // Seconds are the remainder of the time divided by 60 (modulus operator)
      let seconds = timeLeft % 60;
      // If the value of seconds is less than 10, then display seconds with a leading zero
      if (seconds < 10) {
        seconds = `0${seconds}`;
      }
      // The output in MM:SS format
      return `${minutes}:${seconds}`;
    },
    prettyTime() {
      const time = this.time / 60;
      const minutes = parseInt(time);
      const secondes = Math.round((time - minutes) * 60);
      return minutes + ':' + secondes;
    },
    timeLeft() {
      return this.timeLimit - this.timePassed;
    },
  },
  watch: {
    $route: {
      handler: function(route) {
        this.redirect = route.query && route.query.redirect;
      },
      immediate: true,
    },
  },
  methods: {
    showPwd() {
      if (this.pwdType === 'password') {
        this.pwdType = '';
      } else {
        this.pwdType = 'password';
      }
    },
    onImageChange(e) {
      const files = e.target.files || e.dataTransfer.files;
      if (!files.length){
        return;
      }
      this.createImage(files[0]);
    },
    createImage(file) {
      const reader = new FileReader();
      const vm = this;
      reader.onload = (e) => {
        vm.image = e.target.result;
      };
      reader.readAsDataURL(file);
    },
    uploadImage(){
      axios.post('/image/store', { image: this.image }).then(response => {
        if (response.data.success){
          alert(response.data.success);
        }
      });
    },
    smsPwd() {
      this.loading = true;
      userResource
        .smsPwd(this.loginForm)
        .then(response => {
          console.log(response);
          this.loading = false;
        })
        .catch(error => {
          console.log(error);
          this.loading = false;
        })
        .finally(() => {
          this.loading = false;
        });
    },
    createUser() {
      this.newUser.image = this.image;
      this.$refs['userForm'].validate((valid) => {
        if (valid) {
          this.newUser.roles = [this.newUser.role];
          this.userCreating = true;
          userResource
            .register(this.newUser)
            .then(response => {
              this.$message({
                message: 'New user ' + this.newUser.name + '(' + this.newUser.email + ') has been created successfully.',
                type: 'success',
                duration: 5 * 1000,
              });
              this.validateUser.mobile = this.newUser.mobile;
              this.resetNewUser();
              this.dialogFormVisible = false;
              this.validateUserFormVisible = true;
              this.handleFilter();
            })
            .catch(error => {
              console.log(error);
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    sendVerification() {
      this.$refs['verificationForm'].validate((valid) => {
        if (valid) {
          userResource
            .sendVerification(this.validateUser)
            .then(response => {
              this.dialogFormVisible = false;
              this.validateUserFormVisible = false;
              this.verificationFormVisible = false;
              this.handleFilter();
            })
            .catch(error => {
              console.log(error);
              // this.dialogFormVisible = false;
              // this.validateUserFormVisible = true;
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    sendForgetPassword() {
      this.forgetPasswordLoading = true;
      this.$refs['verificationForm'].validate((valid) => {
        if (valid) {
          userResource
            .sendForgetPassword(this.forgetPassword)
            .then(response => {
              if (response.success === true){
                this.forgetPasswordValidatedCode = true;
                this.forgetPasswordUsername = false;
                this.start();
              }
            })
            .catch(error => {
              console.log(error);
              this.forgetPasswordLoading = false;
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    verifyForgetPassword() {
      this.forgetPasswordLoading = true;
      this.$refs['verificationForm'].validate((valid) => {
        if (valid) {
          userResource
            .verifyForgetPassword(this.forgetPassword)
            .then(response => {
              if (response.success === true){
                this.forgetPasswordUsername = false;
                this.forgetPasswordFormVisible = false;
                this.start();
              }
            })
            .catch(error => {
              console.log(error);
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    sendNewVerification() {
      this.$refs['verificationForm'].validate((valid) => {
        if (valid) {
          userResource
            .sendVerification(this.newVerification)
            .then(response => {
              this.dialogFormVisible = false;
              this.validateUserFormVisible = false;
              this.verificationFormVisible = false;
              this.handleFilter();
            })
            .catch(error => {
              console.log(error);
              // this.dialogFormVisible = false;
              // this.validateUserFormVisible = true;
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    newVerificationCode() {
      this.$refs['verificationForm'].validate((valid) => {
        if (valid) {
          userResource
            .newVerificationCode(this.newVerification)
            .then(response => {
              console.log(response);
            })
            .catch(error => {
              console.log(error);
            })
            .finally(() => {});
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    handleLogin() {
      this.$refs.loginForm.validate(valid => {
        if (valid) {
          this.loading = true;
          this.$store.dispatch('user/login', this.loginForm)
            .then(() => {
              this.$router.push({ path: this.redirect || '/' });
              this.loading = false;
            })
            .catch(() => {
              this.loading = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    start() {
      if (!this.timer) {
        this.timer = setInterval(() => {
          if (this.time > 0) {
            this.time--;
          } else {
            clearInterval(this.timer);
            this.sound.play();
            this.reset();
          }
        }, 1000);
      }
    },
    resetNewUser() {
      this.newUser = {
        name: '',
        password: '',
        confirmPassword: '',
        role: 'user',
      };
    },
    resetVerification() {
      this.newVerification = {
        mobile: '',
        verification: '',
      };
    },
    handleRegister() {
      this.resetNewUser();
      this.dialogFormVisible = true;
      this.$nextTick(() => {
        this.$refs['userForm'].clearValidate();
      });
    },
    handleForgetPassword() {
      this.forgetPasswordFormVisible = true;
      this.forgetPasswordUsername = true;
      this.forgetPasswordValidatedCode = false;
      this.forgetPasswordLoading = false;
    },
    handleVerification() {
      this.resetVerification();
      this.verificationFormVisible = true;
    },
  },
};
</script>
<style>
  .login-container{
    background: url(/images/login-bg.jpg) no-repeat center center;
    -webkit-background-size: cover;
    background-size: cover;
  }
</style>
<style rel="stylesheet/scss" lang="scss">
$bg:#FFF;
$light_gray:#eee;

/* reset element-ui css */
.login-container {
  .el-input {
    display: inline-block;
    height: 47px;
    width: 85%;
    input {
      background: transparent;
      border: 0px;
      -webkit-appearance: none;
      border-radius: 0px;
      padding: 12px 5px 12px 15px;
      color: #999;
      height: 47px;
      &:-webkit-autofill {
        -webkit-box-shadow: 0 0 0px 1000px $bg inset !important;
        -webkit-text-fill-color: #000 !important;
      }
    }
  }
  .el-form-item {
    border: none;
    background: rgba(0, 0, 0, 0.1);
    border-radius: 5px;
    color: #454545;
  }
}
.el-form-item {
  margin-bottom: 2px !important;
}
</style>

<style rel="stylesheet/scss" lang="scss" scoped>
$bg:#FFF;
$dark_gray:#889aa4;
$light_gray:#eee;
.login-container {
  position: fixed;
  height: 100%;
  width: 100%;
  background-color: $bg;
  .login-form {
    position: absolute;
    left: 0;
    right: 0;
    width: 520px;
    max-width: 100%;
    padding: 15px 5px 15px 5px;
    margin: 120px auto;
    /*height: 550px;*/
    border-radius: 0px;
  }
  .tips {
    font-size: 14px;
    color: #fff;
    margin-bottom: 10px;
    span {
      &:first-of-type {
        margin-right: 16px;
      }
    }
  }
  .svg-container {
    padding: 6px 5px 6px 15px;
    color: $dark_gray;
    vertical-align: middle;
    width: 30px;
    display: inline-block;
  }
  .title {
    height: 40px;
    line-height: 40px;
    font-size: 26px;
    font-weight: 400;
    color: $light_gray;
    margin: 0px auto 40px auto;
    text-align: center;
    font-weight: bold;
  }
  .show-pwd {
    position: absolute;
    right: 10px;
    top: 7px;
    font-size: 16px;
    color: $dark_gray;
    cursor: pointer;
    user-select: none;
  }
  .sms-pwd{
    position: absolute;
    top: 7px;
    cursor: pointer;
    user-select: none;
  }
  .set-language {
    color: #fff;
    position: absolute;
    top: 40px;
    right: 35px;
  }
}

.el-dialog__headerbtn{
  padding: 5px !important;
  border: 1px solid #aaa !important;
  border-radius: 5px !important;
  position: relative !important;
  top: -30px !important;
  right: -10px !important;
  background: #ffff !important;
}
.el-dialog__header{
  border-bottom: 1px solid #ddd !important;
}
.timer{
  color: red;
  display: contents;
}
.new-button {
  display: inline-block;
  padding: 8px 12px;
  cursor: pointer;
  border-radius: 4px;
  background-color: #3369ab;
  font-size: 16px;
  color: #fff;
}
input[type="file"] {
  position: absolute;
  z-index: -1;
  top: 6px;
  left: 0;
  font-size: 15px;
  color: rgb(153,153,153);
}
.button-wrap {
  position: relative;
}
@media (max-width: 575.98px) {
  .login-form {
    width: 80% !important;
  }
}
@media (max-width: 575.98px) {
  .el-dialog {
    width: 80% !important;
  }
}

/* Small devices (landscape phones, less than 768px) */
@media (max-width: 767.98px) {
  .login-form {
    width: 80% !important;
  }
}
@media (max-width: 767.98px) {
  .el-dialog {
    width: 80% !important;
  }
}

/* Medium devices (tablets, less than 992px) */
@media (max-width: 991.98px) {
  .el-dialog {
    width: 30% !important;
  }
}

/* Large devices (desktops, less than 1200px) */
@media (max-width: 1199.98px) {
  .el-dialog {
    width: 30% !important;
  }

}

/* Extra large devices (large desktops) */
/* No media query since the extra-large breakpoint has no upper bound on its width */
</style>
